package physcomp.androidbluetooth;

import android.os.Handler;
import android.os.SystemClock;
import android.os.Bundle;

import android.bluetooth.BluetoothSocket;
import android.content.Intent;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;
import android.app.ProgressDialog;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.os.AsyncTask;

import java.io.IOException;
import java.util.UUID;
import java.io.InputStream;


public class programControl extends AppCompatActivity {

    Button btnTest, btnDiscoFox, btnDis, btnWaltz, btnStop, btnSpeed, btnWalk, btnSex, btnMode;
    TextView speedText, myLabel;
    String address = null;
    String address2 = null;
    private ProgressDialog progress;
    BluetoothAdapter myBluetooth = null;
    BluetoothSocket btSocket = null;
    BluetoothSocket btSocket2 = null;
    private boolean isBtConnected = false;
    private boolean running = false;
    private int speeding = 0;
    Runnable mRunningProgram;
    Handler mHandler = new Handler();
    //SPP UUID. Look for it
    static final UUID myUUID = UUID.fromString("00001101-0000-1000-8000-00805F9B34FB");
    Thread workerThread;
    byte[] readBuffer;
    int readBufferPosition;
    byte[] readBuffer2;
    int readBufferPosition2;
    int counter;
    volatile boolean stopWorker;
    InputStream mmInputStream;
    InputStream mmInputStream2;
    private String Dance = "nothing";
    Thread inputThread;
    boolean restart = false;
    float timeLastTap, timeFirstTap, speed, nextBeatTime;
    float threshold = 2f;
    int tabcount = 0;
    boolean male = true;
    boolean guidemode = true;


    @Override
    protected void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);

        Intent newint = getIntent();
        address = newint.getStringExtra(DeviceList.EXTRA_ADDRESS); //receive the address of the bluetooth device
        address2 = newint.getStringExtra(DeviceList.EXTRA_ADDRESS_2);
        //view of the programControl
        setContentView(R.layout.activity_program_control);

        //call the widgtes
        btnTest = (Button)findViewById(R.id.button2);
        btnDiscoFox = (Button)findViewById(R.id.button3);
        btnDis = (Button)findViewById(R.id.button4);
        btnWaltz = (Button)findViewById(R.id.button5);
        btnWalk = (Button)findViewById(R.id.button9);
        btnStop = (Button)findViewById(R.id.button6);
        btnSpeed = (Button)findViewById(R.id.button7);
        speedText = (TextView)findViewById(R.id.textView3);
        myLabel = (TextView)findViewById(R.id.label);
        btnSex = (Button)findViewById(R.id.button10);
        btnMode = (Button)findViewById(R.id.button11);

        new ConnectBT().execute(); //Call the class to connect


        final Runnable inputRunnable = new Runnable() {
            @Override
            public void run() {
                while (!Thread.interrupted()){
                    if (Dance.equals("Test")){
                        testMotor();
                    }
                    if (Dance.equals("Disco Fox")){
                        startDiscoFox();
                    }
                    if (Dance.equals("Waltz")){
                        startWaltz();
                    }
                    if (Dance.equals("Walk")){
                        startWalk();
                    }
                }

            }
        };

        btnSex.setOnClickListener(new View.OnClickListener()
        {
            @Override
            public void onClick(View v)
            {
                male=!male;
                if(male)
                {
                    btnSex.setText("Male");
                }
                else
                {
                    btnSex.setText("Female");
                }
            }
        });


        btnMode.setOnClickListener(new View.OnClickListener()
        {
            @Override
            public void onClick(View v)
            {
                guidemode=!guidemode;
                if(guidemode)
                {
                    btnMode.setText("Guide Mode");
                }
                else
                {
                    btnMode.setText("Freestyle Mode");
                }
            }
        });

        //commands to be sent to bluetooth
        btnTest.setOnClickListener(new View.OnClickListener()
        {
            @Override
            public void onClick(View v)
            {
                if (inputThread != null){
                    inputThread.interrupt();
                }
                Dance = "Test";
                inputThread = new Thread(inputRunnable);
                inputThread.start();
            }
        });

        btnDiscoFox.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v)
            {
                if (inputThread != null){
                    inputThread.interrupt();
                }
                Dance = "Disco Fox";
                inputThread = new Thread(inputRunnable);
                inputThread.start();
            }
        });

        btnWaltz.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v)
            {
                if (inputThread != null){
                    inputThread.interrupt();
                }
                Dance = "Waltz";
                inputThread = new Thread(inputRunnable);
                inputThread.start();
            }
        });

        btnWalk.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v)
            {
                if (inputThread != null){
                    inputThread.interrupt();
                }
                Dance = "Walk";
                inputThread = new Thread(inputRunnable);
                inputThread.start();
            }
        });

        btnDis.setOnClickListener(new View.OnClickListener()
        {
            @Override
            public void onClick(View v)
            {
                Disconnect(); //close connection
            }
        });

        btnStop.setOnClickListener(new View.OnClickListener()
        {
            @Override
            public void onClick(View v)
            {
                inputThread.interrupt();
            }
        });

        btnSpeed.setOnClickListener(new View.OnClickListener()
        {
            @Override
            public void onClick(View v)
            {
                float tabTime = SystemClock.uptimeMillis();
                if (tabTime > timeLastTap + speed * threshold ){
                    timeFirstTap = tabTime;
                    timeLastTap = tabTime;
                    speed = 1000;
                    speedText.setText(Float.toString(speed));
                    tabcount = 1;
                }
                else
                {
                    speed = (tabTime - timeFirstTap)/tabcount;
                    speedText.setText(Float.toString(speed));
                    tabcount++;
                    timeLastTap = tabTime;
                }
            }
        });


    }

    private void Disconnect()
    {
        if (btSocket!=null) //If the btSocket is busy
        {
            try
            {
                inputThread.interrupt();
                btSocket.close(); //close connection
                btSocket2.close(); //close connection

            }
            catch (IOException e)
            { msg("Error: " + e);}
        }
        finish(); //return to the first layout

    }

    void fourBeats()
    {
        if (btSocket!=null && btSocket2 != null)
        {
            try
            {
                while (nextBeatTime < SystemClock.uptimeMillis() + 200)
                {
                    nextBeatTime+=speed;
                }
                while (SystemClock.uptimeMillis() < nextBeatTime)
                {

                }
                nextBeatTime+=speed;
                if (male){
                    btSocket.getOutputStream().write("a".getBytes());
                }
                else
                {
                    btSocket2.getOutputStream().write("a".getBytes());
                }
                while (SystemClock.uptimeMillis() < nextBeatTime)
                {

                }
                nextBeatTime+=speed;
                if (male){
                    btSocket.getOutputStream().write("a".getBytes());
                }
                else
                {
                    btSocket2.getOutputStream().write("a".getBytes());
                }
                while (SystemClock.uptimeMillis() < nextBeatTime)
                {

                }
                nextBeatTime+=speed;
                if (male){
                    btSocket.getOutputStream().write("a".getBytes());
                }
                else
                {
                    btSocket2.getOutputStream().write("a".getBytes());
                }
                while (SystemClock.uptimeMillis() < nextBeatTime)
                {

                }
                nextBeatTime+=speed;
                if (male){
                    btSocket.getOutputStream().write("a".getBytes());
                }
                else
                {
                    btSocket2.getOutputStream().write("a".getBytes());
                }
            }
            catch (IOException e)
            {
                Log.d("DEBUG", "Error");
            }
        }
    }

    boolean interrupt(){
        if (restart){
            SystemClock.sleep(5000);
            fourBeats();
            restart = false;
            return true;
        }
        return false;
    }

    private void startWalk()
    {
        if (btSocket!=null && btSocket2 != null)
        {
            try
            {
                while (nextBeatTime < SystemClock.uptimeMillis() + 200)
                {
                    nextBeatTime+=speed;
                }
                fourBeats();
                while(!inputThread.isInterrupted()){
                    if (interrupt()){
                        continue;
                    }
                    //msg("nextBeatTime0: " + nextBeatTime);
                    //Log.d("OUTPUT", String.valueOf(nextBeatTime));
                    while (SystemClock.uptimeMillis() < nextBeatTime)
                    {

                    }
                    nextBeatTime+=speed;
                    //msg("nextBeatTime1: " + nextBeatTime);
                    //Log.d("OUTPUT", String.valueOf(nextBeatTime));
                    if (male){
                        btSocket.getOutputStream().write("5".toString().getBytes());
                    }
                    else
                    {
                        btSocket2.getOutputStream().write("5".toString().getBytes());
                    }
                    while (SystemClock.uptimeMillis() < nextBeatTime)
                    {

                    }
                    nextBeatTime+=speed;
                    //msg("nextBeatTime2: " + nextBeatTime);
                    // Log.d("OUTPUT", String.valueOf(nextBeatTime));
                    if (interrupt()){
                        continue;
                    }
                    if (male){
                        btSocket2.getOutputStream().write("5".toString().getBytes());
                    }
                    else
                    {
                        btSocket.getOutputStream().write("5".toString().getBytes());
                    }
                    //nextBeatTime+=speed;
                }
            }
            catch (IOException e)
            {
                Log.d("DEBUG", "Error");
            }
        }
    }

    private void startDiscoFox()
    {
        if (btSocket!=null && btSocket2 != null)
        {
            try
            {
                while (nextBeatTime < SystemClock.uptimeMillis() + 200)
                {
                    System.out.println("Next beat time ++: " + nextBeatTime + " " + SystemClock.uptimeMillis());
                    nextBeatTime+=speed;
                }
                fourBeats();
                while(!inputThread.isInterrupted()){
                    if (interrupt()){
                        continue;
                    }

                    while (SystemClock.uptimeMillis() < nextBeatTime)
                    {

                    }
                    nextBeatTime+=speed;
                    if (male){
                        if (guidemode){
                            btSocket.getOutputStream().write("7".toString().getBytes());
                        } else {
                            btSocket.getOutputStream().write("5".toString().getBytes());
                        }
                    } else {
                        if (guidemode){
                            btSocket2.getOutputStream().write("6".toString().getBytes());
                        } else {
                            btSocket2.getOutputStream().write("5".toString().getBytes());
                        }
                    }
                    while (SystemClock.uptimeMillis() < nextBeatTime)
                    {

                    }
                    nextBeatTime+=speed;
                    if (interrupt()){
                        continue;
                    }
                    if (male){
                        if (guidemode){
                            btSocket2.getOutputStream().write("7".toString().getBytes());
                        } else {
                            btSocket2.getOutputStream().write("5".toString().getBytes());
                        }
                    } else {
                        if (guidemode){
                            btSocket.getOutputStream().write("6".toString().getBytes());
                        } else {
                            btSocket.getOutputStream().write("5".toString().getBytes());
                        }
                    }
                    while (SystemClock.uptimeMillis() < nextBeatTime)
                    {

                    }
                    nextBeatTime+=speed;
                    if (interrupt()){
                        continue;
                    }
                    if (male){
                        if (guidemode){
                            btSocket.getOutputStream().write("5".toString().getBytes());
                        } else {
                            btSocket.getOutputStream().write("5".toString().getBytes());
                        }
                    } else {
                        if (guidemode){
                            btSocket2.getOutputStream().write("5".toString().getBytes());
                        } else {
                            btSocket2.getOutputStream().write("5".toString().getBytes());
                        }
                    }
                    while (SystemClock.uptimeMillis() < nextBeatTime)
                    {

                    }
                    nextBeatTime+=speed;
                    if (interrupt()){
                        continue;
                    }
                    if (male){
                        if (guidemode){
                            btSocket.getOutputStream().write("6".toString().getBytes());
                        } else {
                            btSocket.getOutputStream().write("5".toString().getBytes());
                        }
                    } else {
                        if (guidemode){
                            btSocket2.getOutputStream().write("7".toString().getBytes());
                        } else {
                            btSocket2.getOutputStream().write("5".toString().getBytes());
                        }
                    }

                    while (SystemClock.uptimeMillis() < nextBeatTime)
                    {

                    }
                    nextBeatTime+=speed;
                    if (interrupt()){
                        continue;
                    }
                    if (male){
                        if (guidemode){
                            btSocket2.getOutputStream().write("6".toString().getBytes());
                        } else {
                            btSocket2.getOutputStream().write("5".toString().getBytes());
                        }
                    } else {
                        if (guidemode){
                            btSocket.getOutputStream().write("7".toString().getBytes());
                        } else {
                            btSocket.getOutputStream().write("5".toString().getBytes());
                        }
                    }
                    while (SystemClock.uptimeMillis() < nextBeatTime)
                    {

                    }
                    nextBeatTime+=speed;
                    if (interrupt()){
                        continue;
                    }
                    if (male){
                        if (guidemode){
                            btSocket.getOutputStream().write("5".toString().getBytes());
                        } else {
                            btSocket.getOutputStream().write("5".toString().getBytes());
                        }
                    } else {
                        if (guidemode){
                            btSocket2.getOutputStream().write("5".toString().getBytes());
                        } else {
                            btSocket2.getOutputStream().write("5".toString().getBytes());
                        }
                    }
                    //nextBeatTime+=speed;
                }
            }
            catch (IOException e)
            {
                Log.d("DEBUG", "Error");
            }
        }
    }

    private void startWaltz()
    {
        if (btSocket!=null && btSocket2 != null) {
            try {
                while (nextBeatTime < SystemClock.uptimeMillis() + 200)
                {
                    System.out.println("Next beat time ++: " + nextBeatTime + " " + SystemClock.uptimeMillis());
                    nextBeatTime+=speed;
                }
                fourBeats();
                while(!inputThread.isInterrupted()) {
                    if (interrupt()) {
                        continue;
                    }
                    while ((nextBeatTime - timeFirstTap) / (3 * speed) > 0.5 || (nextBeatTime - timeFirstTap) / (3 * speed) < 0.5){
                        nextBeatTime+=speed;
                    }
                    while (SystemClock.uptimeMillis() < nextBeatTime) {

                    }
                    nextBeatTime += speed;
                    if (male) {
                        if (guidemode) {
                            btSocket2.getOutputStream().write("7".toString().getBytes());
                        } else {
                            btSocket2.getOutputStream().write("5".toString().getBytes());
                        }
                    } else {
                        if (guidemode) {
                            btSocket.getOutputStream().write("6".toString().getBytes());
                        } else {
                            btSocket.getOutputStream().write("5".toString().getBytes());
                        }
                    }
                    while (SystemClock.uptimeMillis() < nextBeatTime) {

                    }
                    nextBeatTime += speed;
                    if (interrupt()) {
                        continue;
                    }
                    if (male) {
                        if (guidemode) {
                            btSocket.getOutputStream().write("7".toString().getBytes());
                        } else {
                            btSocket.getOutputStream().write("5".toString().getBytes());
                        }
                    } else {
                        if (guidemode) {
                            btSocket2.getOutputStream().write("6".toString().getBytes());
                        } else {
                            btSocket2.getOutputStream().write("5".toString().getBytes());
                        }
                    }
                    while (SystemClock.uptimeMillis() < nextBeatTime) {

                    }
                    nextBeatTime += speed;
                    if (interrupt()) {
                        continue;
                    }
                    if (male) {
                        if (guidemode) {
                            btSocket2.getOutputStream().write("5".toString().getBytes());
                        } else {
                            btSocket2.getOutputStream().write("5".toString().getBytes());
                        }
                    } else {
                        if (guidemode) {
                            btSocket.getOutputStream().write("5".toString().getBytes());
                        } else {
                            btSocket.getOutputStream().write("5".toString().getBytes());
                        }
                    }
                    while (SystemClock.uptimeMillis() < nextBeatTime) {

                    }
                    nextBeatTime += speed;
                    if (interrupt()) {
                        continue;
                    }
                    if (male) {
                        if (guidemode) {
                            btSocket.getOutputStream().write("6".toString().getBytes());
                        } else {
                            btSocket.getOutputStream().write("5".toString().getBytes());
                        }
                    } else {
                        if (guidemode) {
                            btSocket2.getOutputStream().write("7".toString().getBytes());
                        } else {
                            btSocket2.getOutputStream().write("5".toString().getBytes());
                        }
                    }

                    while (SystemClock.uptimeMillis() < nextBeatTime) {

                    }
                    nextBeatTime += speed;
                    if (interrupt()) {
                        continue;
                    }
                    if (male) {
                        if (guidemode) {
                            btSocket2.getOutputStream().write("6".toString().getBytes());
                        } else {
                            btSocket2.getOutputStream().write("5".toString().getBytes());
                        }
                    } else {
                        if (guidemode) {
                            btSocket.getOutputStream().write("7".toString().getBytes());
                        } else {
                            btSocket.getOutputStream().write("5".toString().getBytes());
                        }
                    }
                    while (SystemClock.uptimeMillis() < nextBeatTime) {

                    }
                    nextBeatTime += speed;
                    if (interrupt()) {
                        continue;
                    }
                    if (male) {
                        if (guidemode) {
                            btSocket.getOutputStream().write("5".toString().getBytes());
                        } else {
                            btSocket.getOutputStream().write("5".toString().getBytes());
                        }
                    } else {
                        if (guidemode) {
                            btSocket2.getOutputStream().write("5".toString().getBytes());
                        } else {
                            btSocket2.getOutputStream().write("5".toString().getBytes());
                        }
                    }
                    //nextBeatTime+=speed;
                }
            } catch (Exception e) {
                Log.d("DEBUG", "Error");
            }
        }

    }

    private void testMotor()
    {
        if (btSocket != null && btSocket2 != null)
        {
            try
            {
                btSocket.getOutputStream().write("3".toString().getBytes());
                btSocket2.getOutputStream().write("3".toString().getBytes());
                SystemClock.sleep(10000);
                btSocket.getOutputStream().write("4".toString().getBytes());
                btSocket2.getOutputStream().write("4".toString().getBytes());
                SystemClock.sleep(10000);
                btSocket.getOutputStream().write("5".toString().getBytes());
                btSocket2.getOutputStream().write("5".toString().getBytes());
                SystemClock.sleep(10000);
                btSocket.getOutputStream().write("6".toString().getBytes());
                btSocket2.getOutputStream().write("6".toString().getBytes());
                SystemClock.sleep(10000);
                btSocket.getOutputStream().write("7".toString().getBytes());
                btSocket2.getOutputStream().write("7".toString().getBytes());
                SystemClock.sleep(10000);
            }
            catch (IOException e)
            {
                Log.d("DEBUG", "Error");
            }
        }
    }

    void reactOnInput(String sInput)
    {
        if (sInput.equals("ERROR!!!\r")){
            restart = true;
        }

    }


    void beginListenForData()
    {
        final Handler handler = new Handler();
        final byte delimiter = 10; //This is the ASCII code for a newline character

        stopWorker = false;
        readBufferPosition = 0;
        readBuffer = new byte[1024];
        readBufferPosition2 = 0;
        readBuffer2 = new byte[1024];
        workerThread = new Thread(new Runnable()
        {
            public void run()
            {
                while(!Thread.currentThread().isInterrupted() && !stopWorker)
                {
                    try
                    {
                        int bytesAvailable = mmInputStream.available();
                        if(bytesAvailable > 0)
                        {
                            byte[] packetBytes = new byte[bytesAvailable];
                            mmInputStream.read(packetBytes);
                            for(int i=0;i<bytesAvailable;i++)
                            {
                                byte b = packetBytes[i];
                                if(b == delimiter)
                                {
                                    byte[] encodedBytes = new byte[readBufferPosition];
                                    System.arraycopy(readBuffer, 0, encodedBytes, 0, encodedBytes.length);
                                    final String data = new String(encodedBytes, "US-ASCII");
                                    readBufferPosition = 0;
                                    Log.d("OUTPUT3", data);
                                    handler.post(new Runnable()
                                    {
                                        public void run()
                                        {
                                            myLabel.setText("1: " + data);
                                        }
                                    });
                                    reactOnInput(data);
                                }
                                else
                                {
                                    readBuffer[readBufferPosition++] = b;
                                }
                            }
                        }
                        bytesAvailable = mmInputStream2.available();
                        if(bytesAvailable > 0)
                        {
                            byte[] packetBytes = new byte[bytesAvailable];
                            mmInputStream2.read(packetBytes);
                            for(int i=0;i<bytesAvailable;i++)
                            {
                                byte b = packetBytes[i];
                                if(b == delimiter)
                                {
                                    byte[] encodedBytes = new byte[readBufferPosition2];
                                    System.arraycopy(readBuffer2, 0, encodedBytes, 0, encodedBytes.length);
                                    final String data = new String(encodedBytes, "US-ASCII");
                                    readBufferPosition2 = 0;
                                    Log.d("OUTPUT2", data);
                                    handler.post(new Runnable()
                                    {
                                        public void run()
                                        {
                                            myLabel.setText("2: " + data);
                                        }
                                    });
                                    reactOnInput(data);
                                }
                                else
                                {
                                    readBuffer2[readBufferPosition2++] = b;
                                }
                            }
                        }
                    }
                    catch (IOException ex)
                    {
                        stopWorker = true;
                    }
                }
            }
        });

        workerThread.start();
    }

    // fast way to call Toast
    private void msg(String s)
    {
        Toast.makeText(getApplicationContext(),s,Toast.LENGTH_LONG).show();
    }

    /*@Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_led_control, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }*/

    private class ConnectBT extends AsyncTask<Void, Void, Void>  // UI thread
    {
        private boolean ConnectSuccess = true; //if it's here, it's almost connected

        @Override
        protected void onPreExecute()
        {
            progress = ProgressDialog.show(programControl.this, "Connecting...", "Please wait!!!");  //show a progress dialog
        }

        @Override
        protected Void doInBackground(Void... devices) //while the progress dialog is shown, the connection is done in background
        {
            try
            {
                if (btSocket == null || !isBtConnected || btSocket2 == null)
                {
                    myBluetooth = BluetoothAdapter.getDefaultAdapter();//get the mobile bluetooth device
                    BluetoothDevice dispositivo = myBluetooth.getRemoteDevice(address);//connects to the device's address and checks if it's available
                    btSocket = dispositivo.createInsecureRfcommSocketToServiceRecord(myUUID);//create a RFCOMM (SPP) connection
                    BluetoothAdapter.getDefaultAdapter().cancelDiscovery();
                    mmInputStream = btSocket.getInputStream();
                    btSocket.connect();//start connection

                    BluetoothDevice dispositivo2 = myBluetooth.getRemoteDevice(address2);
                    btSocket2 = dispositivo2.createInsecureRfcommSocketToServiceRecord(myUUID);//create a RFCOMM (SPP) connection
                    BluetoothAdapter.getDefaultAdapter().cancelDiscovery();
                    mmInputStream2 = btSocket2.getInputStream();
                    btSocket2.connect();//start connection
                }
            }
            catch (IOException e)
            {
                ConnectSuccess = false;//if the try failed, you can check the exception here
            }
            return null;
        }
        @Override
        protected void onPostExecute(Void result) //after the doInBackground, it checks if everything went fine
        {
            super.onPostExecute(result);

            if (!ConnectSuccess)
            {
                msg("Connection Failed. Is it a SPP Bluetooth? Try again.");
                finish();
            }
            else
            {
                msg("Connected.");
                isBtConnected = true;
                beginListenForData();
            }
            progress.dismiss();
        }
    }
}
